var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
var NAMESPACE = 'wc-materializecss-carousel';
var win = window;
var doc = document;
var plt = {
    $flags$: 0,
    $resourcesUrl$: '',
    jmp: function (h) { return h(); },
    raf: function (h) { return requestAnimationFrame(h); },
    ael: function (el, eventName, listener, opts) { return el.addEventListener(eventName, listener, opts); },
    rel: function (el, eventName, listener, opts) { return el.removeEventListener(eventName, listener, opts); },
};
var supportsConstructibleStylesheets = /*@__PURE__*/ (function () {
    try {
        new CSSStyleSheet();
        return true;
    }
    catch (e) { }
    return false;
})();
var hostRefs = new WeakMap();
var getHostRef = function (ref) { return hostRefs.get(ref); };
var registerInstance = function (lazyInstance, hostRef) { return hostRefs.set(hostRef.$lazyInstance$ = lazyInstance, hostRef); };
var registerHost = function (elm) {
    {
        var hostRef_1 = {
            $flags$: 0,
            $hostElement$: elm,
            $instanceValues$: new Map()
        };
        hostRef_1.$onReadyPromise$ = new Promise(function (r) { return hostRef_1.$onReadyResolve$ = r; });
        return hostRefs.set(elm, hostRef_1);
    }
};
var isMemberInElement = function (elm, memberName) { return memberName in elm; };
var consoleError = function (e) { return console.error(e); };
var moduleCache = /*@__PURE__*/ new Map();
var loadModule = function (cmpMeta, hostRef, hmrVersionId) {
    // loadModuleImport
    var exportName = cmpMeta.$tagName$.replace(/-/g, '_');
    var bundleId = (cmpMeta.$lazyBundleIds$);
    var module = moduleCache.get(bundleId);
    if (module) {
        return module[exportName];
    }
    return import(
    /* webpackInclude: /\.entry\.js$/ */
    /* webpackExclude: /\.system\.entry\.js$/ */
    /* webpackMode: "lazy" */
    "./" + bundleId + ".entry.js" + '').then(function (importedModule) {
        {
            moduleCache.set(bundleId, importedModule);
        }
        return importedModule[exportName];
    }, consoleError);
};
var styles = new Map();
var cssVarShim = /*@__PURE__*/ win.__stencil_cssshim;
var queueCongestion = 0;
var queuePending = false;
var queueDomReads = [];
var queueDomWrites = [];
var queueDomWritesLow = [];
var queueTask = function (queue, write) { return function (cb) {
    queue.push(cb);
    if (!queuePending) {
        queuePending = true;
        if (write && plt.$flags$ & 4 /* queueSync */) {
            nextTick(flush);
        }
        else {
            plt.raf(flush);
        }
    }
}; };
var consume = function (queue) {
    for (var i = 0; i < queue.length; i++) {
        try {
            queue[i](performance.now());
        }
        catch (e) {
            consoleError(e);
        }
    }
    queue.length = 0;
};
var consumeTimeout = function (queue, timeout) {
    var i = 0;
    var ts = 0;
    while (i < queue.length && (ts = performance.now()) < timeout) {
        try {
            queue[i++](ts);
        }
        catch (e) {
            consoleError(e);
        }
    }
    if (i === queue.length) {
        queue.length = 0;
    }
    else if (i !== 0) {
        queue.splice(0, i);
    }
};
var flush = function () {
    queueCongestion++;
    // always force a bunch of medium callbacks to run, but still have
    // a throttle on how many can run in a certain time
    // DOM READS!!!
    consume(queueDomReads);
    var timeout = (plt.$flags$ & 6 /* queueMask */) === 2 /* appLoaded */
        ? performance.now() + (10 * Math.ceil(queueCongestion * (1.0 / 22.0)))
        : Infinity;
    // DOM WRITES!!!
    consumeTimeout(queueDomWrites, timeout);
    consumeTimeout(queueDomWritesLow, timeout);
    if (queueDomWrites.length > 0) {
        queueDomWritesLow.push.apply(queueDomWritesLow, queueDomWrites);
        queueDomWrites.length = 0;
    }
    if (queuePending = ((queueDomReads.length + queueDomWrites.length + queueDomWritesLow.length) > 0)) {
        // still more to do yet, but we've run out of time
        // let's let this thing cool off and try again in the next tick
        plt.raf(flush);
    }
    else {
        queueCongestion = 0;
    }
};
var nextTick = /*@__PURE__*/ function (cb) { return Promise.resolve().then(cb); };
var writeTask = /*@__PURE__*/ queueTask(queueDomWrites, true);
/**
 * Default style mode id
 */
/**
 * Reusable empty obj/array
 * Don't add values to these!!
 */
var EMPTY_OBJ = {};
var isDef = function (v) { return v != null; };
var toLowerCase = function (str) { return str.toLowerCase(); };
var isComplexType = function (o) { return ['object', 'function'].includes(typeof o); };
var getDynamicImportFunction = function (namespace) {
    return "__sc_import_" + namespace.replace(/\s|-/g, '_');
};
var patchEsm = function () {
    // @ts-ignore
    if (!(win.CSS && win.CSS.supports && win.CSS.supports('color', 'var(--c)'))) {
        // @ts-ignore
        return import('./css-shim-3ea8955c-3ea8955c.js');
    }
    return Promise.resolve();
};
var patchBrowser = function () { return __awaiter(_this, void 0, void 0, function () {
    var importMeta, regex, scriptElm, opts, resourcesUrl;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                importMeta = "";
                regex = new RegExp("/" + NAMESPACE + "(.esm)?.js$");
                scriptElm = Array.from(doc.querySelectorAll('script')).find(function (s) { return (regex.test(s.src) ||
                    s.getAttribute('data-namespace') === NAMESPACE); });
                opts = scriptElm['data-opts'];
                if (!(importMeta !== '')) return [3 /*break*/, 1];
                return [2 /*return*/, Object.assign({}, opts, { resourcesUrl: new URL('.', importMeta).href })];
            case 1:
                resourcesUrl = new URL('.', new URL(scriptElm.getAttribute('data-resources-url') || scriptElm.src, win.location.href));
                patchDynamicImport(resourcesUrl.href);
                if (!!window.customElements) return [3 /*break*/, 3];
                // @ts-ignore
                return [4 /*yield*/, import('./dom-860d8016-860d8016.js')];
            case 2:
                // @ts-ignore
                _a.sent();
                _a.label = 3;
            case 3: return [2 /*return*/, Object.assign({}, opts, { resourcesUrl: resourcesUrl.href })];
        }
    });
}); };
var patchDynamicImport = function (base) {
    var importFunctionName = getDynamicImportFunction(NAMESPACE);
    try {
        win[importFunctionName] = new Function('w', 'return import(w);');
    }
    catch (e) {
        var moduleMap_1 = new Map();
        win[importFunctionName] = function (src) {
            var url = new URL(src, base).href;
            var mod = moduleMap_1.get(url);
            if (!mod) {
                var script_1 = doc.createElement('script');
                script_1.type = 'module';
                script_1.src = URL.createObjectURL(new Blob(["import * as m from '" + url + "'; window." + importFunctionName + ".m = m;"], { type: 'application/javascript' }));
                mod = new Promise(function (resolve) {
                    script_1.onload = function () {
                        resolve(win[importFunctionName].m);
                        script_1.remove();
                    };
                });
                moduleMap_1.set(url, mod);
                doc.head.appendChild(script_1);
            }
            return mod;
        };
    }
};
var parsePropertyValue = function (propValue, propType) {
    // ensure this value is of the correct prop type
    if (propValue != null && !isComplexType(propValue)) {
        if (propType & 4 /* Boolean */) {
            // per the HTML spec, any string value means it is a boolean true value
            // but we'll cheat here and say that the string "false" is the boolean false
            return (propValue === 'false' ? false : propValue === '' || !!propValue);
        }
        // redundant return here for better minification
        return propValue;
    }
    // not sure exactly what type we want
    // so no need to change to a different type
    return propValue;
};
var HYDRATED_CLASS = 'hydrated';
var rootAppliedStyles = new WeakMap();
var registerStyle = function (scopeId, cssText, allowCS) {
    var style = styles.get(scopeId);
    if (supportsConstructibleStylesheets && allowCS) {
        style = (style || new CSSStyleSheet());
        style.replace(cssText);
    }
    else {
        style = cssText;
    }
    styles.set(scopeId, style);
};
var addStyle = function (styleContainerNode, cmpMeta, mode, hostElm) {
    var scopeId = getScopeId(cmpMeta.$tagName$);
    var style = styles.get(scopeId);
    // if an element is NOT connected then getRootNode() will return the wrong root node
    // so the fallback is to always use the document for the root node in those cases
    styleContainerNode = (styleContainerNode.nodeType === 11 /* DocumentFragment */ ? styleContainerNode : doc);
    if (style) {
        if (typeof style === 'string') {
            styleContainerNode = styleContainerNode.head || styleContainerNode;
            var appliedStyles = rootAppliedStyles.get(styleContainerNode);
            var styleElm = void 0;
            if (!appliedStyles) {
                rootAppliedStyles.set(styleContainerNode, appliedStyles = new Set());
            }
            if (!appliedStyles.has(scopeId)) {
                {
                    if (cssVarShim) {
                        styleElm = cssVarShim.createHostStyle(hostElm, scopeId, style, !!(cmpMeta.$flags$ & 10 /* needsScopedEncapsulation */));
                        var newScopeId = styleElm['s-sc'];
                        if (newScopeId) {
                            scopeId = newScopeId;
                            // we don't want to add this styleID to the appliedStyles Set
                            // since the cssVarShim might need to apply several different
                            // stylesheets for the same component
                            appliedStyles = null;
                        }
                    }
                    else {
                        styleElm = doc.createElement('style');
                        styleElm.innerHTML = style;
                    }
                    styleContainerNode.insertBefore(styleElm, styleContainerNode.querySelector('link'));
                }
                if (appliedStyles) {
                    appliedStyles.add(scopeId);
                }
            }
        }
        else if (!styleContainerNode.adoptedStyleSheets.includes(style)) {
            styleContainerNode.adoptedStyleSheets = styleContainerNode.adoptedStyleSheets.concat([
                style
            ]);
        }
    }
    return scopeId;
};
var attachStyles = function (elm, cmpMeta, mode) {
    var styleId = addStyle(elm.getRootNode(), cmpMeta, mode, elm);
};
var getScopeId = function (tagName, mode) { return 'sc-' + (tagName); };
/**
 * Production h() function based on Preact by
 * Jason Miller (@developit)
 * Licensed under the MIT License
 * https://github.com/developit/preact/blob/master/LICENSE
 *
 * Modified for Stencil's compiler and vdom
 */
// const stack: any[] = [];
// export function h(nodeName: string | d.FunctionalComponent, vnodeData: d.PropsType, child?: d.ChildType): d.VNode;
// export function h(nodeName: string | d.FunctionalComponent, vnodeData: d.PropsType, ...children: d.ChildType[]): d.VNode;
var h = function (nodeName, vnodeData) {
    var children = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        children[_i - 2] = arguments[_i];
    }
    var child = null;
    var simple = false;
    var lastSimple = false;
    var key;
    var vNodeChildren = [];
    var walk = function (c) {
        for (var i = 0; i < c.length; i++) {
            child = c[i];
            if (Array.isArray(child)) {
                walk(child);
            }
            else if (child != null && typeof child !== 'boolean') {
                if (simple = typeof nodeName !== 'function' && !isComplexType(child)) {
                    child = String(child);
                }
                if (simple && lastSimple) {
                    // If the previous child was simple (string), we merge both
                    vNodeChildren[vNodeChildren.length - 1].$text$ += child;
                }
                else {
                    // Append a new vNode, if it's text, we create a text vNode
                    vNodeChildren.push(simple ? { $flags$: 0, $text$: child } : child);
                }
                lastSimple = simple;
            }
        }
    };
    walk(children);
    if (vnodeData) {
        // normalize class / classname attributes
        {
            key = vnodeData.key || undefined;
        }
        {
            var classData_1 = vnodeData.className || vnodeData.class;
            if (classData_1) {
                vnodeData.class = typeof classData_1 !== 'object'
                    ? classData_1
                    : Object.keys(classData_1)
                        .filter(function (k) { return classData_1[k]; })
                        .join(' ');
            }
        }
    }
    if (typeof nodeName === 'function') {
        // nodeName is a functional component
        return nodeName(vnodeData, vNodeChildren, vdomFnUtils);
    }
    var vnode = {
        $flags$: 0,
        $tag$: nodeName,
        $children$: vNodeChildren.length > 0 ? vNodeChildren : null,
        $elm$: undefined,
        $attrs$: vnodeData,
    };
    {
        vnode.$key$ = key;
    }
    return vnode;
};
var Host = {};
var isHost = function (node) {
    return node && node.$tag$ === Host;
};
var vdomFnUtils = {
    'forEach': function (children, cb) { return children.map(convertToPublic).forEach(cb); },
    'map': function (children, cb) { return children.map(convertToPublic).map(cb).map(convertToPrivate); }
};
var convertToPublic = function (node) {
    return {
        vattrs: node.$attrs$,
        vchildren: node.$children$,
        vkey: node.$key$,
        vname: node.$name$,
        vtag: node.$tag$,
        vtext: node.$text$
    };
};
var convertToPrivate = function (node) {
    return {
        $flags$: 0,
        $attrs$: node.vattrs,
        $children$: node.vchildren,
        $key$: node.vkey,
        $name$: node.vname,
        $tag$: node.vtag,
        $text$: node.vtext
    };
};
/**
 * Production setAccessor() function based on Preact by
 * Jason Miller (@developit)
 * Licensed under the MIT License
 * https://github.com/developit/preact/blob/master/LICENSE
 *
 * Modified for Stencil's compiler and vdom
 */
var setAccessor = function (elm, memberName, oldValue, newValue, isSvg, flags) {
    if (oldValue === newValue) {
        return;
    }
    if (memberName === 'class') {
        var classList_1 = elm.classList;
        parseClassList(oldValue).forEach(function (cls) { return classList_1.remove(cls); });
        parseClassList(newValue).forEach(function (cls) { return classList_1.add(cls); });
    }
    else if (memberName === 'style') {
        // update style attribute, css properties and values
        {
            for (var prop in oldValue) {
                if (!newValue || newValue[prop] == null) {
                    if (prop.includes('-')) {
                        elm.style.removeProperty(prop);
                    }
                    else {
                        elm.style[prop] = '';
                    }
                }
            }
        }
        for (var prop in newValue) {
            if (!oldValue || newValue[prop] !== oldValue[prop]) {
                if (prop.includes('-')) {
                    elm.style.setProperty(prop, newValue[prop]);
                }
                else {
                    elm.style[prop] = newValue[prop];
                }
            }
        }
    }
    else if (memberName === 'key')
        ;
    else if (memberName === 'ref') {
        // minifier will clean this up
        if (newValue) {
            newValue(elm);
        }
    }
    else if (memberName.startsWith('on') && !isMemberInElement(elm, memberName)) {
        // Event Handlers
        // so if the member name starts with "on" and the 3rd characters is
        // a capital letter, and it's not already a member on the element,
        // then we're assuming it's an event listener
        if (isMemberInElement(elm, toLowerCase(memberName))) {
            // standard event
            // the JSX attribute could have been "onMouseOver" and the
            // member name "onmouseover" is on the element's prototype
            // so let's add the listener "mouseover", which is all lowercased
            memberName = toLowerCase(memberName.substring(2));
        }
        else {
            // custom event
            // the JSX attribute could have been "onMyCustomEvent"
            // so let's trim off the "on" prefix and lowercase the first character
            // and add the listener "myCustomEvent"
            // except for the first character, we keep the event name case
            memberName = toLowerCase(memberName[2]) + memberName.substring(3);
        }
        if (oldValue) {
            plt.rel(elm, memberName, oldValue, false);
        }
        if (newValue) {
            plt.ael(elm, memberName, newValue, false);
        }
    }
    else {
        // Set property if it exists and it's not a SVG
        var isProp = isMemberInElement(elm, memberName);
        var isComplex = isComplexType(newValue);
        var isCustomElement = elm.tagName.includes('-');
        if ((isProp || (isComplex && newValue !== null)) && !isSvg) {
            try {
                if (isCustomElement) {
                    elm[memberName] = newValue;
                }
                else if (elm[memberName] !== newValue || '') {
                    elm[memberName] = newValue || '';
                }
            }
            catch (e) { }
        }
        if (newValue == null || newValue === false) {
            {
                elm.removeAttribute(memberName);
            }
        }
        else if ((!isProp || (flags & 4 /* isHost */) || isSvg) && !isComplex) {
            newValue = newValue === true ? '' : newValue.toString();
            {
                elm.setAttribute(memberName, newValue);
            }
        }
    }
};
var parseClassList = function (value) { return (!value) ? [] : value.split(/\s+/).filter(function (c) { return c; }); };
var updateElement = function (oldVnode, newVnode, isSvgMode, memberName) {
    // if the element passed in is a shadow root, which is a document fragment
    // then we want to be adding attrs/props to the shadow root's "host" element
    // if it's not a shadow root, then we add attrs/props to the same element
    var elm = (newVnode.$elm$.nodeType === 11 /* DocumentFragment */ && newVnode.$elm$.host) ? newVnode.$elm$.host : newVnode.$elm$;
    var oldVnodeAttrs = (oldVnode && oldVnode.$attrs$) || EMPTY_OBJ;
    var newVnodeAttrs = newVnode.$attrs$ || EMPTY_OBJ;
    {
        // remove attributes no longer present on the vnode by setting them to undefined
        for (memberName in oldVnodeAttrs) {
            if (!(memberName in newVnodeAttrs)) {
                setAccessor(elm, memberName, oldVnodeAttrs[memberName], undefined, isSvgMode, newVnode.$flags$);
            }
        }
    }
    // add new & update changed attributes
    for (memberName in newVnodeAttrs) {
        setAccessor(elm, memberName, oldVnodeAttrs[memberName], newVnodeAttrs[memberName], isSvgMode, newVnode.$flags$);
    }
};
var hostTagName;
var isSvgMode = false;
var createElm = function (oldParentVNode, newParentVNode, childIndex, parentElm) {
    // tslint:disable-next-line: prefer-const
    var newVNode = newParentVNode.$children$[childIndex];
    var i = 0;
    var elm;
    var childNode;
    if (isDef(newVNode.$text$)) {
        // create text node
        newVNode.$elm$ = doc.createTextNode(newVNode.$text$);
    }
    else {
        // create element
        elm = newVNode.$elm$ = (doc.createElement(newVNode.$tag$));
        // add css classes, attrs, props, listeners, etc.
        {
            updateElement(null, newVNode, isSvgMode);
        }
        if (newVNode.$children$) {
            for (i = 0; i < newVNode.$children$.length; ++i) {
                // create the node
                childNode = createElm(oldParentVNode, newVNode, i);
                // return node could have been null
                if (childNode) {
                    // append our new node
                    elm.appendChild(childNode);
                }
            }
        }
    }
    return newVNode.$elm$;
};
var addVnodes = function (parentElm, before, parentVNode, vnodes, startIdx, endIdx) {
    var containerElm = (parentElm);
    var childNode;
    for (; startIdx <= endIdx; ++startIdx) {
        if (vnodes[startIdx]) {
            childNode = createElm(null, parentVNode, startIdx);
            if (childNode) {
                vnodes[startIdx].$elm$ = childNode;
                containerElm.insertBefore(childNode, before);
            }
        }
    }
};
var removeVnodes = function (vnodes, startIdx, endIdx, elm) {
    for (; startIdx <= endIdx; ++startIdx) {
        if (isDef(vnodes[startIdx])) {
            elm = vnodes[startIdx].$elm$;
            callNodeRefs(vnodes[startIdx], true);
            // remove the vnode's element from the dom
            elm.remove();
        }
    }
};
var updateChildren = function (parentElm, oldCh, newVNode, newCh) {
    var oldStartIdx = 0;
    var newStartIdx = 0;
    var idxInOld = 0;
    var i = 0;
    var oldEndIdx = oldCh.length - 1;
    var oldStartVnode = oldCh[0];
    var oldEndVnode = oldCh[oldEndIdx];
    var newEndIdx = newCh.length - 1;
    var newStartVnode = newCh[0];
    var newEndVnode = newCh[newEndIdx];
    var node;
    var elmToMove;
    while (oldStartIdx <= oldEndIdx && newStartIdx <= newEndIdx) {
        if (oldStartVnode == null) {
            // Vnode might have been moved left
            oldStartVnode = oldCh[++oldStartIdx];
        }
        else if (oldEndVnode == null) {
            oldEndVnode = oldCh[--oldEndIdx];
        }
        else if (newStartVnode == null) {
            newStartVnode = newCh[++newStartIdx];
        }
        else if (newEndVnode == null) {
            newEndVnode = newCh[--newEndIdx];
        }
        else if (isSameVnode(oldStartVnode, newStartVnode)) {
            patch(oldStartVnode, newStartVnode);
            oldStartVnode = oldCh[++oldStartIdx];
            newStartVnode = newCh[++newStartIdx];
        }
        else if (isSameVnode(oldEndVnode, newEndVnode)) {
            patch(oldEndVnode, newEndVnode);
            oldEndVnode = oldCh[--oldEndIdx];
            newEndVnode = newCh[--newEndIdx];
        }
        else if (isSameVnode(oldStartVnode, newEndVnode)) {
            patch(oldStartVnode, newEndVnode);
            parentElm.insertBefore(oldStartVnode.$elm$, oldEndVnode.$elm$.nextSibling);
            oldStartVnode = oldCh[++oldStartIdx];
            newEndVnode = newCh[--newEndIdx];
        }
        else if (isSameVnode(oldEndVnode, newStartVnode)) {
            patch(oldEndVnode, newStartVnode);
            parentElm.insertBefore(oldEndVnode.$elm$, oldStartVnode.$elm$);
            oldEndVnode = oldCh[--oldEndIdx];
            newStartVnode = newCh[++newStartIdx];
        }
        else {
            // createKeyToOldIdx
            idxInOld = -1;
            {
                for (i = oldStartIdx; i <= oldEndIdx; ++i) {
                    if (oldCh[i] && isDef(oldCh[i].$key$) && oldCh[i].$key$ === newStartVnode.$key$) {
                        idxInOld = i;
                        break;
                    }
                }
            }
            if (idxInOld >= 0) {
                elmToMove = oldCh[idxInOld];
                if (elmToMove.$tag$ !== newStartVnode.$tag$) {
                    node = createElm(oldCh && oldCh[newStartIdx], newVNode, idxInOld);
                }
                else {
                    patch(elmToMove, newStartVnode);
                    oldCh[idxInOld] = undefined;
                    node = elmToMove.$elm$;
                }
                newStartVnode = newCh[++newStartIdx];
            }
            else {
                // new element
                node = createElm(oldCh && oldCh[newStartIdx], newVNode, newStartIdx);
                newStartVnode = newCh[++newStartIdx];
            }
            if (node) {
                {
                    oldStartVnode.$elm$.parentNode.insertBefore(node, oldStartVnode.$elm$);
                }
            }
        }
    }
    if (oldStartIdx > oldEndIdx) {
        addVnodes(parentElm, (newCh[newEndIdx + 1] == null ? null : newCh[newEndIdx + 1].$elm$), newVNode, newCh, newStartIdx, newEndIdx);
    }
    else if (newStartIdx > newEndIdx) {
        removeVnodes(oldCh, oldStartIdx, oldEndIdx);
    }
};
var isSameVnode = function (vnode1, vnode2) {
    // compare if two vnode to see if they're "technically" the same
    // need to have the same element tag, and same key to be the same
    if (vnode1.$tag$ === vnode2.$tag$) {
        {
            return vnode1.$key$ === vnode2.$key$;
        }
        return true;
    }
    return false;
};
var patch = function (oldVNode, newVNode) {
    var elm = newVNode.$elm$ = oldVNode.$elm$;
    var oldChildren = oldVNode.$children$;
    var newChildren = newVNode.$children$;
    if (!isDef(newVNode.$text$)) {
        // element node
        {
            {
                // either this is the first render of an element OR it's an update
                // AND we already know it's possible it could have changed
                // this updates the element's css classes, attrs, props, listeners, etc.
                updateElement(oldVNode, newVNode, isSvgMode);
            }
        }
        if (isDef(oldChildren) && isDef(newChildren)) {
            // looks like there's child vnodes for both the old and new vnodes
            updateChildren(elm, oldChildren, newVNode, newChildren);
        }
        else if (isDef(newChildren)) {
            // no old child vnodes, but there are new child vnodes to add
            if (isDef(oldVNode.$text$)) {
                // the old vnode was text, so be sure to clear it out
                elm.textContent = '';
            }
            // add the new vnode children
            addVnodes(elm, null, newVNode, newChildren, 0, newChildren.length - 1);
        }
        else if (isDef(oldChildren)) {
            // no new child vnodes, but there are old child vnodes to remove
            removeVnodes(oldChildren, 0, oldChildren.length - 1);
        }
    }
    else if (oldVNode.$text$ !== newVNode.$text$) {
        // update the text content for the text only vnode
        // and also only if the text is different than before
        elm.textContent = newVNode.$text$;
    }
};
var callNodeRefs = function (vNode, isDestroy) {
    if (vNode) {
        vNode.$attrs$ && vNode.$attrs$.ref && vNode.$attrs$.ref(isDestroy ? null : vNode.$elm$);
        vNode.$children$ && vNode.$children$.forEach(function (vChild) {
            callNodeRefs(vChild, isDestroy);
        });
    }
};
var renderVdom = function (hostElm, hostRef, cmpMeta, renderFnResults) {
    hostTagName = toLowerCase(hostElm.tagName);
    var oldVNode = hostRef.$vnode$ || { $flags$: 0 };
    var rootVnode = isHost(renderFnResults)
        ? renderFnResults
        : h(null, null, renderFnResults);
    rootVnode.$tag$ = null;
    rootVnode.$flags$ |= 4 /* isHost */;
    hostRef.$vnode$ = rootVnode;
    rootVnode.$elm$ = oldVNode.$elm$ = (hostElm);
    // synchronous patch
    patch(oldVNode, rootVnode);
};
var scheduleUpdate = function (elm, hostRef, cmpMeta, isInitialLoad) {
    {
        hostRef.$flags$ |= 16 /* isQueuedForUpdate */;
    }
    var instance = hostRef.$lazyInstance$;
    var promise;
    // there is no ancestorc omponent or the ancestor component
    // has already fired off its lifecycle update then
    // fire off the initial update
    var update = function () { return updateComponent(elm, hostRef, cmpMeta, instance, isInitialLoad); };
    return then(promise, function () { return writeTask(update); });
};
var updateComponent = function (elm, hostRef, cmpMeta, instance, isInitialLoad) {
    // updateComponent
    {
        hostRef.$flags$ &= ~16 /* isQueuedForUpdate */;
    }
    {
        elm['s-lr'] = false;
    }
    if (isInitialLoad) {
        // DOM WRITE!
        attachStyles(elm, cmpMeta, hostRef.$modeName$);
    }
    {
        {
            // tell the platform we're actively rendering
            // if a value is changed within a render() then
            // this tells the platform not to queue the change
            hostRef.$flags$ |= 4 /* isActiveRender */;
            try {
                // looks like we've got child nodes to render into this host element
                // or we need to update the css class/attrs on the host element
                // DOM WRITE!
                renderVdom(elm, hostRef, cmpMeta, instance.render());
            }
            catch (e) {
                consoleError(e);
            }
            hostRef.$flags$ &= ~4 /* isActiveRender */;
        }
    }
    if (cssVarShim) {
        cssVarShim.updateHost(elm);
    }
    // set that this component lifecycle rendering has completed
    {
        elm['s-lr'] = true;
    }
    {
        hostRef.$flags$ |= 2 /* hasRendered */;
    }
    if (elm['s-rc'].length > 0) {
        // ok, so turns out there are some child host elements
        // waiting on this parent element to load
        // let's fire off all update callbacks waiting
        elm['s-rc'].forEach(function (cb) { return cb(); });
        elm['s-rc'].length = 0;
    }
    postUpdateComponent(elm, hostRef);
};
var postUpdateComponent = function (elm, hostRef, ancestorsActivelyLoadingChildren) {
    if (!elm['s-al']) {
        var instance = hostRef.$lazyInstance$;
        var ancestorComponent = hostRef.$ancestorComponent$;
        if (!(hostRef.$flags$ & 64 /* hasLoadedComponent */)) {
            hostRef.$flags$ |= 64 /* hasLoadedComponent */;
            {
                // DOM WRITE!
                // add the css class that this element has officially hydrated
                elm.classList.add(HYDRATED_CLASS);
            }
            {
                safeCall(instance, 'componentDidLoad');
            }
            {
                hostRef.$onReadyResolve$(elm);
            }
            if (!ancestorComponent) {
                appDidLoad();
            }
        }
        // load events fire from bottom to top
        // the deepest elements load first then bubbles up
        if (ancestorComponent) {
            // ok so this element already has a known ancestor component
            // let's make sure we remove this element from its ancestor's
            // known list of child elements which are actively loading
            if (ancestorsActivelyLoadingChildren = ancestorComponent['s-al']) {
                // remove this element from the actively loading map
                ancestorsActivelyLoadingChildren.delete(elm);
                // the ancestor's initializeComponent method will do the actual checks
                // to see if the ancestor is actually loaded or not
                // then let's call the ancestor's initializeComponent method if there's no length
                // (which actually ends up as this method again but for the ancestor)
                if (ancestorsActivelyLoadingChildren.size === 0) {
                    ancestorComponent['s-al'] = undefined;
                    ancestorComponent['s-init']();
                }
            }
            hostRef.$ancestorComponent$ = undefined;
        }
        // ( •_•)
        // ( •_•)>⌐■-■
        // (⌐■_■)
    }
};
var forceUpdate = function (elm, cmpMeta) {
    {
        var hostRef = getHostRef(elm);
        if (hostRef.$flags$ & 2 /* hasRendered */) {
            scheduleUpdate(elm, hostRef, cmpMeta, false);
        }
    }
};
var appDidLoad = function () {
    // on appload
    // we have finish the first big initial render
    {
        doc.documentElement.classList.add(HYDRATED_CLASS);
    }
    {
        plt.$flags$ |= 2 /* appLoaded */;
    }
};
var safeCall = function (instance, method, arg) {
    if (instance && instance[method]) {
        try {
            return instance[method](arg);
        }
        catch (e) {
            consoleError(e);
        }
    }
    return undefined;
};
var then = function (promise, thenFn) {
    return promise && promise.then ? promise.then(thenFn) : thenFn();
};
var getValue = function (ref, propName) { return getHostRef(ref).$instanceValues$.get(propName); };
var setValue = function (ref, propName, newVal, cmpMeta) {
    // check our new property value against our internal value
    var hostRef = getHostRef(ref);
    var elm = hostRef.$hostElement$;
    var oldVal = hostRef.$instanceValues$.get(propName);
    var flags = hostRef.$flags$;
    newVal = parsePropertyValue(newVal, cmpMeta.$members$[propName][0]);
    if (newVal !== oldVal && (!(flags & 8 /* isConstructingInstance */) || oldVal === undefined)) {
        // gadzooks! the property's value has changed!!
        // set our new value!
        hostRef.$instanceValues$.set(propName, newVal);
        if (hostRef.$lazyInstance$) {
            if ((flags & (4 /* isActiveRender */ | 2 /* hasRendered */ | 16 /* isQueuedForUpdate */)) === 2 /* hasRendered */) {
                // looks like this value actually changed, so we've got work to do!
                // but only if we've already rendered, otherwise just chill out
                // queue that we need to do an update, but don't worry about queuing
                // up millions cuz this function ensures it only runs once
                scheduleUpdate(elm, hostRef, cmpMeta, false);
            }
        }
    }
};
var proxyComponent = function (Cstr, cmpMeta, flags) {
    if (cmpMeta.$members$) {
        // It's better to have a const than two Object.entries()
        var members = Object.entries(cmpMeta.$members$);
        var prototype_1 = Cstr.prototype;
        members.forEach(function (_a) {
            var memberName = _a[0], memberFlags = _a[1][0];
            if (((memberFlags & 31 /* Prop */) ||
                ((flags & 2 /* proxyState */) &&
                    (memberFlags & 32 /* State */)))) {
                // proxyComponent - prop
                Object.defineProperty(prototype_1, memberName, {
                    get: function () {
                        // proxyComponent, get value
                        return getValue(this, memberName);
                    },
                    set: function (newValue) {
                        // proxyComponent, set value
                        setValue(this, memberName, newValue, cmpMeta);
                    },
                    configurable: true,
                    enumerable: true
                });
            }
        });
        if ((flags & 1 /* isElementConstructor */)) {
            var attrNameToPropName_1 = new Map();
            prototype_1.attributeChangedCallback = function (attrName, _oldValue, newValue) {
                var _this = this;
                plt.jmp(function () {
                    var propName = attrNameToPropName_1.get(attrName);
                    _this[propName] = newValue === null && typeof _this[propName] === 'boolean'
                        ? false
                        : newValue;
                });
            };
            // create an array of attributes to observe
            // and also create a map of html attribute name to js property name
            Cstr.observedAttributes = members
                .filter(function (_a) {
                var _ = _a[0], m = _a[1];
                return m[0] & 15;
            } /* HasAttribute */) // filter to only keep props that should match attributes
                .map(function (_a) {
                var propName = _a[0], m = _a[1];
                var attrName = m[1] || propName;
                attrNameToPropName_1.set(attrName, propName);
                return attrName;
            });
        }
    }
    return Cstr;
};
var initializeComponent = function (elm, hostRef, cmpMeta, hmrVersionId, Cstr) { return __awaiter(_this, void 0, void 0, function () {
    var style, scopeId, ancestorComponent, schedule;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!((hostRef.$flags$ & 32 /* hasInitializedComponent */) === 0)) return [3 /*break*/, 3];
                // we haven't initialized this element yet
                hostRef.$flags$ |= 32 /* hasInitializedComponent */;
                // lazy loaded components
                // request the component's implementation to be
                // wired up with the host element
                Cstr = loadModule(cmpMeta);
                if (!Cstr.then) return [3 /*break*/, 2];
                return [4 /*yield*/, Cstr];
            case 1:
                // Await creates a micro-task avoid if possible
                Cstr = _a.sent();
                _a.label = 2;
            case 2:
                if (!Cstr.isProxied) {
                    proxyComponent(Cstr, cmpMeta, 2 /* proxyState */);
                    Cstr.isProxied = true;
                }
                // ok, time to construct the instance
                // but let's keep track of when we start and stop
                // so that the getters/setters don't incorrectly step on data
                {
                    hostRef.$flags$ |= 8 /* isConstructingInstance */;
                }
                // construct the lazy-loaded component implementation
                // passing the hostRef is very important during
                // construction in order to directly wire together the
                // host element and the lazy-loaded instance
                try {
                    new Cstr(hostRef);
                }
                catch (e) {
                    consoleError(e);
                }
                {
                    hostRef.$flags$ &= ~8 /* isConstructingInstance */;
                }
                if (!Cstr.$isStyleRegistered$ && Cstr.style) {
                    style = Cstr.style;
                    scopeId = getScopeId(cmpMeta.$tagName$);
                    registerStyle(scopeId, style, !!(cmpMeta.$flags$ & 1 /* shadowDomEncapsulation */));
                    Cstr.$isStyleRegistered$ = true;
                }
                _a.label = 3;
            case 3:
                ancestorComponent = hostRef.$ancestorComponent$;
                schedule = function () { return scheduleUpdate(elm, hostRef, cmpMeta, true); };
                if (ancestorComponent && ancestorComponent['s-lr'] === false && ancestorComponent['s-rc']) {
                    // this is the intial load and this component it has an ancestor component
                    // but the ancestor component has NOT fired its will update lifecycle yet
                    // so let's just cool our jets and wait for the ancestor to continue first
                    // this will get fired off when the ancestor component
                    // finally gets around to rendering its lazy self
                    // fire off the initial update
                    ancestorComponent['s-rc'].push(schedule);
                }
                else {
                    schedule();
                }
                return [2 /*return*/];
        }
    });
}); };
var connectedCallback = function (elm, cmpMeta) {
    if ((plt.$flags$ & 1 /* isTmpDisconnected */) === 0) {
        // connectedCallback
        var hostRef_2 = getHostRef(elm);
        if (!(hostRef_2.$flags$ & 1 /* hasConnected */)) {
            // first time this component has connected
            hostRef_2.$flags$ |= 1 /* hasConnected */;
            {
                // find the first ancestor component (if there is one) and register
                // this component as one of the actively loading child components for its ancestor
                var ancestorComponent = elm;
                while ((ancestorComponent = (ancestorComponent.parentNode || ancestorComponent.host))) {
                    // climb up the ancestors looking for the first
                    // component that hasn't finished its lifecycle update yet
                    if ((ancestorComponent['s-init'] && ancestorComponent['s-lr'] === false)) {
                        // we found this components first ancestor component
                        // keep a reference to this component's ancestor component
                        hostRef_2.$ancestorComponent$ = ancestorComponent;
                        // ensure there is an array to contain a reference to each of the child components
                        // and set this component as one of the ancestor's child components it should wait on
                        (ancestorComponent['s-al'] = ancestorComponent['s-al'] || new Set()).add(elm);
                        break;
                    }
                }
            }
            // Lazy properties
            // https://developers.google.com/web/fundamentals/web-components/best-practices#lazy-properties
            if (cmpMeta.$members$) {
                Object.entries(cmpMeta.$members$).forEach(function (_a) {
                    var memberName = _a[0], memberFlags = _a[1][0];
                    if (memberFlags & 31 /* Prop */ && elm.hasOwnProperty(memberName)) {
                        var value = elm[memberName];
                        delete elm[memberName];
                        elm[memberName] = value;
                    }
                });
            }
            {
                // connectedCallback, taskQueue, initialLoad
                // angular sets attribute AFTER connectCallback
                // https://github.com/angular/angular/issues/18909
                // https://github.com/angular/angular/issues/19940
                nextTick(function () { return initializeComponent(elm, hostRef_2, cmpMeta); });
            }
        }
    }
};
var disconnectedCallback = function (elm) {
    if ((plt.$flags$ & 1 /* isTmpDisconnected */) === 0) {
        var hostRef = getHostRef(elm);
        // clear CSS var-shim tracking
        if (cssVarShim) {
            cssVarShim.removeHost(elm);
        }
    }
};
var bootstrapLazy = function (lazyBundles, options) {
    if (options === void 0) { options = {}; }
    var cmpTags = [];
    var exclude = options.exclude || [];
    var head = doc.head;
    var customElements = win.customElements;
    var y = /*@__PURE__*/ head.querySelector('meta[charset]');
    var visibilityStyle = /*@__PURE__*/ doc.createElement('style');
    var appLoadFallback;
    Object.assign(plt, options);
    plt.$resourcesUrl$ = new URL(options.resourcesUrl || './', doc.baseURI).href;
    if (options.syncQueue) {
        plt.$flags$ |= 4 /* queueSync */;
    }
    lazyBundles.forEach(function (lazyBundle) { return lazyBundle[1].forEach(function (compactMeta) {
        var cmpMeta = {
            $flags$: compactMeta[0],
            $tagName$: compactMeta[1],
            $members$: compactMeta[2],
            $listeners$: compactMeta[3],
        };
        var tagName = cmpMeta.$tagName$;
        var HostElement = /** @class */ (function (_super) {
            __extends(class_1, _super);
            // StencilLazyHost
            function class_1(self) {
                var _this = 
                // @ts-ignore
                _super.call(this, self) || this;
                self = _this;
                {
                    _this['s-lr'] = false;
                    _this['s-rc'] = [];
                }
                registerHost(self);
                return _this;
            }
            class_1.prototype.connectedCallback = function () {
                var _this = this;
                if (appLoadFallback) {
                    clearTimeout(appLoadFallback);
                    appLoadFallback = null;
                }
                plt.jmp(function () { return connectedCallback(_this, cmpMeta); });
            };
            class_1.prototype.disconnectedCallback = function () {
                var _this = this;
                plt.jmp(function () { return disconnectedCallback(_this); });
            };
            class_1.prototype['s-init'] = function () {
                var hostRef = getHostRef(this);
                if (hostRef.$lazyInstance$) {
                    postUpdateComponent(this, hostRef);
                }
            };
            class_1.prototype['s-hmr'] = function (hmrVersionId) {
            };
            class_1.prototype.forceUpdate = function () {
                forceUpdate(this, cmpMeta);
            };
            class_1.prototype.componentOnReady = function () {
                return getHostRef(this).$onReadyPromise$;
            };
            return class_1;
        }(HTMLElement));
        cmpMeta.$lazyBundleIds$ = lazyBundle[0];
        if (!exclude.includes(tagName) && !customElements.get(tagName)) {
            cmpTags.push(tagName);
            customElements.define(tagName, proxyComponent(HostElement, cmpMeta, 1 /* isElementConstructor */));
        }
    }); });
    // visibilityStyle.innerHTML = cmpTags.map(t => `${t}:not(.hydrated)`) + '{display:none}';
    visibilityStyle.innerHTML = cmpTags + '{visibility:hidden}.hydrated{visibility:inherit}';
    visibilityStyle.setAttribute('data-styles', '');
    head.insertBefore(visibilityStyle, y ? y.nextSibling : head.firstChild);
    // Fallback appLoad event
    plt.jmp(function () { return appLoadFallback = setTimeout(appDidLoad, 30); });
};
var createEvent = function (ref, name, flags) {
    var elm = getElement(ref);
    return {
        emit: function (detail) { return elm.dispatchEvent(new (CustomEvent)(name, {
            bubbles: !!(flags & 4 /* Bubbles */),
            composed: !!(flags & 2 /* Composed */),
            cancelable: !!(flags & 1 /* Cancellable */),
            detail: detail
        })); }
    };
};
var getElement = function (ref) { return getHostRef(ref).$hostElement$; };
function createCommonjsModule(fn, module) {
    return module = { exports: {} }, fn(module, module.exports), module.exports;
}
var carouselWithDependency = createCommonjsModule(function (module, exports) {
    !function (t) { t.Package ? M = {} : t.M = {}, M.jQueryLoaded = !!t.jQuery; }(window), exports.nodeType || (!module.nodeType && module.exports && (exports = module.exports = M), exports.default = M), M.keys = { TAB: 9, ENTER: 13, ESC: 27, ARROW_UP: 38, ARROW_DOWN: 40 }, M.tabPressed = !1, M.keyDown = !1;
    var docHandleKeydown = function (t) { M.keyDown = !0, t.which !== M.keys.TAB && t.which !== M.keys.ARROW_DOWN && t.which !== M.keys.ARROW_UP || (M.tabPressed = !0); }, docHandleKeyup = function (t) { M.keyDown = !1, t.which !== M.keys.TAB && t.which !== M.keys.ARROW_DOWN && t.which !== M.keys.ARROW_UP || (M.tabPressed = !1); }, docHandleFocus = function (t) { M.keyDown && document.body.classList.add("keyboard-focused"); }, docHandleBlur = function (t) { document.body.classList.remove("keyboard-focused"); };
    document.addEventListener("keydown", docHandleKeydown, !0), document.addEventListener("keyup", docHandleKeyup, !0), document.addEventListener("focus", docHandleFocus, !0), document.addEventListener("blur", docHandleBlur, !0), M.initializeJqueryWrapper = function (t, e, i) { jQuery.fn[e] = function (n) { if (t.prototype[n]) {
        var t_1 = Array.prototype.slice.call(arguments, 1);
        if ("get" === n.slice(0, 3)) {
            var e_1 = this.first()[0][i];
            return e_1[n].apply(e_1, t_1);
        }
        return this.each(function () { var e = this[i]; e[n].apply(e, t_1); });
    } if ("object" == typeof n || !n)
        return t.init(this, arguments[0]), this; jQuery.error("Method " + n + " does not exist on jQuery." + e); }; }, M.AutoInit = function (t) { var e = t || document.body, i = { Autocomplete: e.querySelectorAll(".autocomplete:not(.no-autoinit)"), Carousel: e.querySelectorAll(".carousel:not(.no-autoinit)"), Chips: e.querySelectorAll(".chips:not(.no-autoinit)"), Collapsible: e.querySelectorAll(".collapsible:not(.no-autoinit)"), Datepicker: e.querySelectorAll(".datepicker:not(.no-autoinit)"), Dropdown: e.querySelectorAll(".dropdown-trigger:not(.no-autoinit)"), Materialbox: e.querySelectorAll(".materialboxed:not(.no-autoinit)"), Modal: e.querySelectorAll(".modal:not(.no-autoinit)"), Parallax: e.querySelectorAll(".parallax:not(.no-autoinit)"), Pushpin: e.querySelectorAll(".pushpin:not(.no-autoinit)"), ScrollSpy: e.querySelectorAll(".scrollspy:not(.no-autoinit)"), FormSelect: e.querySelectorAll("select:not(.no-autoinit)"), Sidenav: e.querySelectorAll(".sidenav:not(.no-autoinit)"), Tabs: e.querySelectorAll(".tabs:not(.no-autoinit)"), TapTarget: e.querySelectorAll(".tap-target:not(.no-autoinit)"), Timepicker: e.querySelectorAll(".timepicker:not(.no-autoinit)"), Tooltip: e.querySelectorAll(".tooltipped:not(.no-autoinit)"), FloatingActionButton: e.querySelectorAll(".fixed-action-btn:not(.no-autoinit)") }; for (var t_2 in i) {
        M[t_2].init(i[t_2]);
    } }, M.objectSelectorString = function (t) { return ((t.prop("tagName") || "") + (t.attr("id") || "") + (t.attr("class") || "")).replace(/\s/g, ""); }, M.guid = function () { function t() { return Math.floor(65536 * (1 + Math.random())).toString(16).substring(1); } return function () { return t() + t() + "-" + t() + "-" + t() + "-" + t() + "-" + t() + t() + t(); }; }(), M.escapeHash = function (t) { return t.replace(/(:|\.|\[|\]|,|=|\/)/g, "\\$1"); }, M.elementOrParentIsFixed = function (t) { var e = $(t), i = e.add(e.parents()), n = !1; return i.each(function () { if ("fixed" === $(this).css("position"))
        return n = !0, !1; }), n; }, M.checkWithinContainer = function (t, e, i) { var n = { top: !1, right: !1, bottom: !1, left: !1 }, s = t.getBoundingClientRect(), r = t === document.body ? Math.max(s.bottom, window.innerHeight) : s.bottom, o = t.scrollLeft, a = t.scrollTop, h = e.left - o, l = e.top - a; return (h < s.left + i || h < i) && (n.left = !0), (h + e.width > s.right - i || h + e.width > window.innerWidth - i) && (n.right = !0), (l < s.top + i || l < i) && (n.top = !0), (l + e.height > r - i || l + e.height > window.innerHeight - i) && (n.bottom = !0), n; }, M.checkPossibleAlignments = function (t, e, i, n) { var s = { top: !0, right: !0, bottom: !0, left: !0, spaceOnTop: null, spaceOnRight: null, spaceOnBottom: null, spaceOnLeft: null }, r = "visible" === getComputedStyle(e).overflow, o = e.getBoundingClientRect(), a = Math.min(o.height, window.innerHeight), h = Math.min(o.width, window.innerWidth), l = t.getBoundingClientRect(), u = e.scrollLeft, c = e.scrollTop, d = i.left - u, f = i.top - c, p = i.top + l.height - c; return s.spaceOnRight = r ? window.innerWidth - (l.left + i.width) : h - (d + i.width), s.spaceOnRight < 0 && (s.left = !1), s.spaceOnLeft = r ? l.right - i.width : d - i.width + l.width, s.spaceOnLeft < 0 && (s.right = !1), s.spaceOnBottom = r ? window.innerHeight - (l.top + i.height + n) : a - (f + i.height + n), s.spaceOnBottom < 0 && (s.top = !1), s.spaceOnTop = r ? l.bottom - (i.height + n) : p - (i.height - n), s.spaceOnTop < 0 && (s.bottom = !1), s; }, M.getOverflowParent = function (t) { return null == t ? null : t === document.body || "visible" !== getComputedStyle(t).overflow ? t : M.getOverflowParent(t.parentElement); }, M.getIdFromTrigger = function (t) { var e = t.getAttribute("data-target"); return e || (e = (e = t.getAttribute("href")) ? e.slice(1) : ""), e; }, M.getDocumentScrollTop = function () { return window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop || 0; }, M.getDocumentScrollLeft = function () { return window.pageXOffset || document.documentElement.scrollLeft || document.body.scrollLeft || 0; };
    var getTime = Date.now || function () { return (new Date).getTime(); };
    M.throttle = function (t, e, i) { var n, s, r, o = null, a = 0; i || (i = {}); var h = function () { a = !1 === i.leading ? 0 : getTime(), o = null, r = t.apply(n, s), n = s = null; }; return function () { var l = getTime(); a || !1 !== i.leading || (a = l); var u = e - (l - a); return n = this, s = arguments, u <= 0 ? (clearTimeout(o), o = null, a = l, r = t.apply(n, s), n = s = null) : o || !1 === i.trailing || (o = setTimeout(h, u)), r; }; }, window.cash = function () { var t, e = document, i = window, n = Array.prototype, s = n.slice, r = n.filter, o = n.push, a = function () { }, h = function (t) { return "function" == typeof t && t.call; }, l = function (t) { return "string" == typeof t; }, u = /^#[\w-]*$/, c = /^\.[\w-]*$/, d = /<.+>/, f = /^\w+$/; function p(t, i) { i = i || e; var n = c.test(t) ? i.getElementsByClassName(t.slice(1)) : f.test(t) ? i.getElementsByTagName(t) : i.querySelectorAll(t); return n; } function m(i) { if (!t) {
        var n = (t = e.implementation.createHTMLDocument(null)).createElement("base");
        n.href = e.location.href, t.head.appendChild(n);
    } return t.body.innerHTML = i, t.body.childNodes; } function g(t) { "loading" !== e.readyState ? t() : e.addEventListener("DOMContentLoaded", t); } function v(t, n) { if (!t)
        return this; if (t.cash && t !== i)
        return t; var s, r = t, o = 0; if (l(t))
        r = u.test(t) ? e.getElementById(t.slice(1)) : d.test(t) ? m(t) : p(t, n);
    else if (h(t))
        return g(t), this; if (!r)
        return this; if (r.nodeType || r === i)
        this[0] = r, this.length = 1;
    else
        for (s = this.length = r.length; o < s; o++)
            this[o] = r[o]; return this; } function y(t, e) { return new v(t, e); } var w = y.fn = y.prototype = v.prototype = { cash: !0, length: 0, push: o, splice: n.splice, map: n.map, init: v }; function _(t, e) { for (var i = t.length, n = 0; n < i && !1 !== e.call(t[n], t[n], n, t); n++)
        ; } function C(t, e) { var i = t && (t.matches || t.webkitMatchesSelector || t.mozMatchesSelector || t.msMatchesSelector || t.oMatchesSelector); return !!i && i.call(t, e); } function b(t) { return l(t) ? C : t.cash ? function (e) { return t.is(e); } : function (t, e) { return t === e; }; } function M(t) { return y(s.call(t).filter(function (t, e, i) { return i.indexOf(t) === e; })); } Object.defineProperty(w, "constructor", { value: y }), y.parseHTML = m, y.noop = a, y.isFunction = h, y.isString = l, y.extend = w.extend = function (t) { t = t || {}; var e = s.call(arguments), i = e.length, n = 1; for (1 === e.length && (t = this, n = 0); n < i; n++)
        if (e[n])
            for (var r in e[n])
                e[n].hasOwnProperty(r) && (t[r] = e[n][r]); return t; }, y.extend({ merge: function (t, e) { for (var i = +e.length, n = t.length, s = 0; s < i; n++, s++)
            t[n] = e[s]; return t.length = n, t; }, each: _, matches: C, unique: M, isArray: Array.isArray, isNumeric: function (t) { return !isNaN(parseFloat(t)) && isFinite(t); } }); var T = y.uid = "_cash" + Date.now(); function x(t) { return t[T] = t[T] || {}; } function L(t, e, i) { return x(t)[e] = i; } function E(t, e) { var i = x(t); return void 0 === i[e] && (i[e] = t.dataset ? t.dataset[e] : y(t).attr("data-" + e)), i[e]; } w.extend({ data: function (t, e) { if (l(t))
            return void 0 === e ? E(this[0], t) : this.each(function (i) { return L(i, t, e); }); for (var i in t)
            this.data(i, t[i]); return this; }, removeData: function (t) { return this.each(function (e) { return function (t, e) { var i = x(t); i ? delete i[e] : t.dataset ? delete t.dataset[e] : y(t).removeAttr("data-" + name); }(e, t); }); } }); var S = /\S+/g; function A(t) { return l(t) && t.match(S); } function B(t, e) { return t.classList ? t.classList.contains(e) : new RegExp("(^| )" + e + "( |$)", "gi").test(t.className); } function k(t, e, i) { t.classList ? t.classList.add(e) : i.indexOf(" " + e + " ") && (t.className += " " + e); } function $(t, e) { t.classList ? t.classList.remove(e) : t.className = t.className.replace(e, ""); } w.extend({ addClass: function (t) { var e = A(t); return e ? this.each(function (t) { var i = " " + t.className + " "; _(e, function (e) { k(t, e, i); }); }) : this; }, attr: function (t, e) { if (t) {
            if (l(t))
                return void 0 === e ? this[0] ? this[0].getAttribute ? this[0].getAttribute(t) : this[0][t] : void 0 : this.each(function (i) { i.setAttribute ? i.setAttribute(t, e) : i[t] = e; });
            for (var i in t)
                this.attr(i, t[i]);
            return this;
        } }, hasClass: function (t) { var e = !1, i = A(t); return i && i.length && this.each(function (t) { return !(e = B(t, i[0])); }), e; }, prop: function (t, e) { if (l(t))
            return void 0 === e ? this[0][t] : this.each(function (i) { i[t] = e; }); for (var i in t)
            this.prop(i, t[i]); return this; }, removeAttr: function (t) { return this.each(function (e) { e.removeAttribute ? e.removeAttribute(t) : delete e[t]; }); }, removeClass: function (t) { if (!arguments.length)
            return this.attr("class", ""); var e = A(t); return e ? this.each(function (t) { _(e, function (e) { $(t, e); }); }) : this; }, removeProp: function (t) { return this.each(function (e) { delete e[t]; }); }, toggleClass: function (t, e) { if (void 0 !== e)
            return this[e ? "addClass" : "removeClass"](t); var i = A(t); return i ? this.each(function (t) { var e = " " + t.className + " "; _(i, function (i) { B(t, i) ? $(t, i) : k(t, i, e); }); }) : this; } }), w.extend({ add: function (t, e) { return M(y.merge(this, y(t, e))); }, each: function (t) { return _(this, t), this; }, eq: function (t) { return y(this.get(t)); }, filter: function (t) { if (!t)
            return this; var e = h(t) ? t : b(t); return y(r.call(this, function (i) { return e(i, t); })); }, first: function () { return this.eq(0); }, get: function (t) { return void 0 === t ? s.call(this) : t < 0 ? this[t + this.length] : this[t]; }, index: function (t) { var e = t ? y(t)[0] : this[0], i = t ? this : y(e).parent().children(); return s.call(i).indexOf(e); }, last: function () { return this.eq(-1); } }); var W, N, D = (W = /(?:^\w|[A-Z]|\b\w)/g, N = /[\s-_]+/g, function (t) { return t.replace(W, function (t, e) { return t[0 === e ? "toLowerCase" : "toUpperCase"](); }).replace(N, ""); }), R = function () { var t = {}, e = document, i = e.createElement("div"), n = i.style; return function (e) { if (e = D(e), t[e])
        return t[e]; var i = e.charAt(0).toUpperCase() + e.slice(1), s = (e + " " + ["webkit", "moz", "ms", "o"].join(i + " ") + i).split(" "); return _(s, function (i) { if (i in n)
        return t[i] = e = t[e] = i, !1; }), t[e]; }; }(); function H(t, e) { return parseInt(i.getComputedStyle(t[0], null)[e], 10) || 0; } function O(t, e, i) { var n, s = E(t, "_cashEvents"), r = s && s[e]; r && (i ? (t.removeEventListener(e, i), (n = r.indexOf(i)) >= 0 && r.splice(n, 1)) : (_(r, function (i) { t.removeEventListener(e, i); }), r = [])); } function q(t, e) { return "&" + encodeURIComponent(t) + "=" + encodeURIComponent(e).replace(/%20/g, "+"); } function I(t) { var e = t.type; if (!e)
        return null; switch (e.toLowerCase()) {
        case "select-one": return function (t) { var e = t.selectedIndex; return e >= 0 ? t.options[e].value : null; }(t);
        case "select-multiple": return function (t) { var e = []; return _(t.options, function (t) { t.selected && e.push(t.value); }), e.length ? e : null; }(t);
        case "radio":
        case "checkbox": return t.checked ? t.value : null;
        default: return t.value ? t.value : null;
    } } function P(t, e, i) { var n = l(e); n || !e.length ? _(t, n ? function (t) { return t.insertAdjacentHTML(i ? "afterbegin" : "beforeend", e); } : function (t, n) { return function (t, e, i) { if (i) {
        var n = t.childNodes[0];
        t.insertBefore(e, n);
    }
    else
        t.appendChild(e); }(t, 0 === n ? e : e.cloneNode(!0), i); }) : _(e, function (e) { return P(t, e, i); }); } y.prefixedProp = R, y.camelCase = D, w.extend({ css: function (t, e) { if (l(t))
            return t = R(t), arguments.length > 1 ? this.each(function (i) { return i.style[t] = e; }) : i.getComputedStyle(this[0])[t]; for (var n in t)
            this.css(n, t[n]); return this; } }), _(["Width", "Height"], function (t) { var e = t.toLowerCase(); w[e] = function () { return this[0].getBoundingClientRect()[e]; }, w["inner" + t] = function () { return this[0]["client" + t]; }, w["outer" + t] = function (e) { return this[0]["offset" + t] + (e ? H(this, "margin" + ("Width" === t ? "Left" : "Top")) + H(this, "margin" + ("Width" === t ? "Right" : "Bottom")) : 0); }; }), w.extend({ off: function (t, e) { return this.each(function (i) { return O(i, t, e); }); }, on: function (t, e, i, n) { var s; if (!l(t)) {
            for (var r in t)
                this.on(r, e, t[r]);
            return this;
        } return h(e) && (i = e, e = null), "ready" === t ? (g(i), this) : (e && (s = i, i = function (t) { for (var i = t.target; !C(i, e);) {
            if (i === this || null === i)
                return i = !1;
            i = i.parentNode;
        } i && s.call(i, t); }), this.each(function (e) { var s = i; n && (s = function () { i.apply(this, arguments), O(e, t, s); }), function (t, e, i) { var n = E(t, "_cashEvents") || L(t, "_cashEvents", {}); n[e] = n[e] || [], n[e].push(i), t.addEventListener(e, i); }(e, t, s); })); }, one: function (t, e, i) { return this.on(t, e, i, !0); }, ready: g, trigger: function (t, e) { if (document.createEvent) {
            var i_1 = document.createEvent("HTMLEvents");
            return i_1.initEvent(t, !0, !1), i_1 = this.extend(i_1, e), this.each(function (t) { return t.dispatchEvent(i_1); });
        } } }), w.extend({ serialize: function () { var t = ""; return _(this[0].elements || this, function (e) { if (!e.disabled && "FIELDSET" !== e.tagName) {
            var i = e.name;
            switch (e.type.toLowerCase()) {
                case "file":
                case "reset":
                case "submit":
                case "button": break;
                case "select-multiple":
                    var n = I(e);
                    null !== n && _(n, function (e) { t += q(i, e); });
                    break;
                default:
                    var s = I(e);
                    null !== s && (t += q(i, s));
            }
        } }), t.substr(1); }, val: function (t) { return void 0 === t ? I(this[0]) : this.each(function (e) { return e.value = t; }); } }), w.extend({ after: function (t) { return y(t).insertAfter(this), this; }, append: function (t) { return P(this, t), this; }, appendTo: function (t) { return P(y(t), this), this; }, before: function (t) { return y(t).insertBefore(this), this; }, clone: function () { return y(this.map(function (t) { return t.cloneNode(!0); })); }, empty: function () { return this.html(""), this; }, html: function (t) { if (void 0 === t)
            return this[0].innerHTML; var e = t.nodeType ? t[0].outerHTML : t; return this.each(function (t) { return t.innerHTML = e; }); }, insertAfter: function (t) { var e = this; return y(t).each(function (t, i) { var n = t.parentNode, s = t.nextSibling; e.each(function (t) { n.insertBefore(0 === i ? t : t.cloneNode(!0), s); }); }), this; }, insertBefore: function (t) { var e = this; return y(t).each(function (t, i) { var n = t.parentNode; e.each(function (e) { n.insertBefore(0 === i ? e : e.cloneNode(!0), t); }); }), this; }, prepend: function (t) { return P(this, t, !0), this; }, prependTo: function (t) { return P(y(t), this, !0), this; }, remove: function () { return this.each(function (t) { if (t.parentNode)
            return t.parentNode.removeChild(t); }); }, text: function (t) { return void 0 === t ? this[0].textContent : this.each(function (e) { return e.textContent = t; }); } }); var z = e.documentElement; return w.extend({ position: function () { var t = this[0]; return { left: t.offsetLeft, top: t.offsetTop }; }, offset: function () { var t = this[0].getBoundingClientRect(); return { top: t.top + i.pageYOffset - z.clientTop, left: t.left + i.pageXOffset - z.clientLeft }; }, offsetParent: function () { return y(this[0].offsetParent); } }), w.extend({ children: function (t) { var e = []; return this.each(function (t) { o.apply(e, t.children); }), e = M(e), t ? e.filter(function (e) { return C(e, t); }) : e; }, closest: function (t) { return !t || this.length < 1 ? y() : this.is(t) ? this.filter(t) : this.parent().closest(t); }, is: function (t) { if (!t)
            return !1; var e = !1, i = b(t); return this.each(function (n) { return !(e = i(n, t)); }), e; }, find: function (t) { if (!t || t.nodeType)
            return y(t && this.has(t).length ? t : null); var e = []; return this.each(function (i) { o.apply(e, p(t, i)); }), M(e); }, has: function (t) { var e = l(t) ? function (e) { return 0 !== p(t, e).length; } : function (e) { return e.contains(t); }; return this.filter(e); }, next: function () { return y(this[0].nextElementSibling); }, not: function (t) { if (!t)
            return this; var e = b(t); return this.filter(function (i) { return !e(i, t); }); }, parent: function () { var t = []; return this.each(function (e) { e && e.parentNode && t.push(e.parentNode); }), M(t); }, parents: function (t) { var i, n = []; return this.each(function (s) { for (i = s; i && i.parentNode && i !== e.body.parentNode;)
            i = i.parentNode, (!t || t && C(i, t)) && n.push(i); }), M(n); }, prev: function () { return y(this[0].previousElementSibling); }, siblings: function (t) { var e = this.parent().children(t), i = this[0]; return e.filter(function (t) { return t !== i; }); } }), y; }();
    var Component = /** @class */ (function () {
        function Component(t, e, i) {
            e instanceof Element || console.error(Error(e + " is not an HTML Element"));
            var n = t.getInstance(e);
            n && n.destroy(), this.el = e, this.$el = cash(e);
        }
        Component.init = function (t, e, i) { var n = null; if (e instanceof Element)
            n = new t(e, i);
        else if (e && (e.jquery || e.cash || e instanceof NodeList)) {
            var s = [];
            for (var n_1 = 0; n_1 < e.length; n_1++)
                s.push(new t(e[n_1], i));
            n = s;
        } return n; };
        return Component;
    }());
    !function (t) { var e = { duration: 200, dist: -100, shift: 0, padding: 0, numVisible: 5, fullWidth: !1, indicators: !1, noWrap: !1, onCycleTo: null };
        var i = /** @class */ (function (_super) {
            __extends(i, _super);
            function i(e, n) {
                var _this = this;
                _this = _super.call(this, i, e, n) || this, _this.el.M_Carousel = _this, _this.options = t.extend({}, i.defaults, n), _this.hasMultipleSlides = _this.$el.find(".carousel-item").length > 1, _this.showIndicators = _this.options.indicators && _this.hasMultipleSlides, _this.noWrap = _this.options.noWrap || !_this.hasMultipleSlides, _this.pressed = !1, _this.dragged = !1, _this.offset = _this.target = 0, _this.images = [], _this.itemWidth = _this.$el.find(".carousel-item").first().innerWidth(), _this.itemHeight = _this.$el.find(".carousel-item").first().innerHeight(), _this.dim = 2 * _this.itemWidth + _this.options.padding || 1, _this._autoScrollBound = _this._autoScroll.bind(_this), _this._trackBound = _this._track.bind(_this), _this.options.fullWidth && (_this.options.dist = 0, _this._setCarouselHeight(), _this.showIndicators && _this.$el.find(".carousel-fixed-item").addClass("with-indicators")), _this.$indicators = t('<ul class="indicators"></ul>'), _this.$el.find(".carousel-item").each(function (e, i) { if (_this.images.push(e), _this.showIndicators) {
                    var e_2 = t('<li class="indicator-item"></li>');
                    0 === i && e_2[0].classList.add("active"), _this.$indicators.append(e_2);
                } }), _this.showIndicators && _this.$el.append(_this.$indicators), _this.count = _this.images.length, _this.options.numVisible = Math.min(_this.count, _this.options.numVisible), _this.xform = "transform", ["webkit", "Moz", "O", "ms"].every(function (t) { var e = t + "Transform"; return void 0 === document.body.style[e] || (_this.xform = e, !1); }), _this._setupEventHandlers(), _this._scroll(_this.offset);
                return _this;
            }
            Object.defineProperty(i, "defaults", {
                get: function () { return e; },
                enumerable: true,
                configurable: true
            });
            i.init = function (t, e) { return _super.init.call(this, this, t, e); };
            i.getInstance = function (t) { return (t.jquery ? t[0] : t).M_Carousel; };
            i.prototype.destroy = function () { this._removeEventHandlers(), this.el.M_Carousel = void 0; };
            i.prototype._setupEventHandlers = function () {
                var _this = this;
                this._handleCarouselTapBound = this._handleCarouselTap.bind(this), this._handleCarouselDragBound = this._handleCarouselDrag.bind(this), this._handleCarouselReleaseBound = this._handleCarouselRelease.bind(this), this._handleCarouselClickBound = this._handleCarouselClick.bind(this), void 0 !== window.ontouchstart && (this.el.addEventListener("touchstart", this._handleCarouselTapBound), this.el.addEventListener("touchmove", this._handleCarouselDragBound), this.el.addEventListener("touchend", this._handleCarouselReleaseBound)), this.el.addEventListener("mousedown", this._handleCarouselTapBound), this.el.addEventListener("mousemove", this._handleCarouselDragBound), this.el.addEventListener("mouseup", this._handleCarouselReleaseBound), this.el.addEventListener("mouseleave", this._handleCarouselReleaseBound), this.el.addEventListener("click", this._handleCarouselClickBound), this.showIndicators && this.$indicators && (this._handleIndicatorClickBound = this._handleIndicatorClick.bind(this), this.$indicators.find(".indicator-item").each(function (t, e) { t.addEventListener("click", _this._handleIndicatorClickBound); }));
                var t = M.throttle(this._handleResize, 200);
                this._handleThrottledResizeBound = t.bind(this), window.addEventListener("resize", this._handleThrottledResizeBound);
            };
            i.prototype._removeEventHandlers = function () {
                var _this = this;
                void 0 !== window.ontouchstart && (this.el.removeEventListener("touchstart", this._handleCarouselTapBound), this.el.removeEventListener("touchmove", this._handleCarouselDragBound), this.el.removeEventListener("touchend", this._handleCarouselReleaseBound)), this.el.removeEventListener("mousedown", this._handleCarouselTapBound), this.el.removeEventListener("mousemove", this._handleCarouselDragBound), this.el.removeEventListener("mouseup", this._handleCarouselReleaseBound), this.el.removeEventListener("mouseleave", this._handleCarouselReleaseBound), this.el.removeEventListener("click", this._handleCarouselClickBound), this.showIndicators && this.$indicators && this.$indicators.find(".indicator-item").each(function (t, e) { t.removeEventListener("click", _this._handleIndicatorClickBound); }), window.removeEventListener("resize", this._handleThrottledResizeBound);
            };
            i.prototype._handleCarouselTap = function (e) { "mousedown" === e.type && t(e.target).is("img") && e.preventDefault(), this.pressed = !0, this.dragged = !1, this.verticalDragged = !1, this.reference = this._xpos(e), this.referenceY = this._ypos(e), this.velocity = this.amplitude = 0, this.frame = this.offset, this.timestamp = Date.now(), clearInterval(this.ticker), this.ticker = setInterval(this._trackBound, 100); };
            i.prototype._handleCarouselDrag = function (t) { var e, i, n, s; if (this.pressed)
                if (e = this._xpos(t), i = this._ypos(t), n = this.reference - e, (s = Math.abs(this.referenceY - i)) < 30 && !this.verticalDragged)
                    (n > 2 || n < -2) && (this.dragged = !0, this.reference = e, this._scroll(this.offset + n));
                else {
                    if (this.dragged)
                        return t.preventDefault(), t.stopPropagation(), !1;
                    this.verticalDragged = !0;
                } if (this.dragged)
                return t.preventDefault(), t.stopPropagation(), !1; };
            i.prototype._handleCarouselRelease = function (t) { if (this.pressed)
                return this.pressed = !1, clearInterval(this.ticker), this.target = this.offset, (this.velocity > 10 || this.velocity < -10) && (this.amplitude = .9 * this.velocity, this.target = this.offset + this.amplitude), this.target = Math.round(this.target / this.dim) * this.dim, this.noWrap && (this.target >= this.dim * (this.count - 1) ? this.target = this.dim * (this.count - 1) : this.target < 0 && (this.target = 0)), this.amplitude = this.target - this.offset, this.timestamp = Date.now(), requestAnimationFrame(this._autoScrollBound), this.dragged && (t.preventDefault(), t.stopPropagation()), !1; };
            i.prototype._handleCarouselClick = function (e) { if (this.dragged)
                return e.preventDefault(), e.stopPropagation(), !1; if (!this.options.fullWidth) {
                var i_2 = t(e.target).closest(".carousel-item").index();
                0 !== this._wrap(this.center) - i_2 && (e.preventDefault(), e.stopPropagation()), this._cycleTo(i_2);
            } };
            i.prototype._handleIndicatorClick = function (e) { e.stopPropagation(); var i = t(e.target).closest(".indicator-item"); i.length && this._cycleTo(i.index()); };
            i.prototype._handleResize = function (t) { this.options.fullWidth ? (this.itemWidth = this.$el.find(".carousel-item").first().innerWidth(), this.imageHeight = this.$el.find(".carousel-item.active").height(), this.dim = 2 * this.itemWidth + this.options.padding, this.offset = 2 * this.center * this.itemWidth, this.target = this.offset, this._setCarouselHeight(!0)) : this._scroll(); };
            i.prototype._setCarouselHeight = function (t) {
                var _this = this;
                var e = this.$el.find(".carousel-item.active").length ? this.$el.find(".carousel-item.active").first() : this.$el.find(".carousel-item").first(), i = e.find("img").first();
                if (i.length)
                    if (i[0].complete) {
                        var t_3 = i.height();
                        if (t_3 > 0)
                            this.$el.css("height", t_3 + "px");
                        else {
                            var t_4 = i[0].naturalWidth, e_3 = i[0].naturalHeight, n = this.$el.width() / t_4 * e_3;
                            this.$el.css("height", n + "px");
                        }
                    }
                    else
                        i.one("load", function (t, e) { _this.$el.css("height", t.offsetHeight + "px"); });
                else if (!t) {
                    var t_5 = e.height();
                    this.$el.css("height", t_5 + "px");
                }
            };
            i.prototype._xpos = function (t) { return t.targetTouches && t.targetTouches.length >= 1 ? t.targetTouches[0].clientX : t.clientX; };
            i.prototype._ypos = function (t) { return t.targetTouches && t.targetTouches.length >= 1 ? t.targetTouches[0].clientY : t.clientY; };
            i.prototype._wrap = function (t) { return t >= this.count ? t % this.count : t < 0 ? this._wrap(this.count + t % this.count) : t; };
            i.prototype._track = function () { var t, e, i, n; e = (t = Date.now()) - this.timestamp, this.timestamp = t, i = this.offset - this.frame, this.frame = this.offset, n = 1e3 * i / (1 + e), this.velocity = .8 * n + .2 * this.velocity; };
            i.prototype._autoScroll = function () { var t, e; this.amplitude && (t = Date.now() - this.timestamp, (e = this.amplitude * Math.exp(-t / this.options.duration)) > 2 || e < -2 ? (this._scroll(this.target - e), requestAnimationFrame(this._autoScrollBound)) : this._scroll(this.target)); };
            i.prototype._scroll = function (e) {
                var _this = this;
                var i, n, s, r, o, a, h, l, u, c;
                this.$el.hasClass("scrolling") || this.el.classList.add("scrolling"), null != this.scrollingTimeout && window.clearTimeout(this.scrollingTimeout), this.scrollingTimeout = window.setTimeout(function () { _this.$el.removeClass("scrolling"); }, this.options.duration);
                var d = this.center, f = 1 / this.options.numVisible;
                if (this.offset = "number" == typeof e ? e : this.offset, this.center = Math.floor((this.offset + this.dim / 2) / this.dim), o = -(r = (s = this.offset - this.center * this.dim) < 0 ? 1 : -1) * s * 2 / this.dim, n = this.count >> 1, this.options.fullWidth ? (h = "translateX(0)", c = 1) : (h = "translateX(" + (this.el.clientWidth - this.itemWidth) / 2 + "px) ", h += "translateY(" + (this.el.clientHeight - this.itemHeight) / 2 + "px)", c = 1 - f * o), this.showIndicators) {
                    var t_6 = this.center % this.count, e_4 = this.$indicators.find(".indicator-item.active");
                    e_4.index() !== t_6 && (e_4.removeClass("active"), this.$indicators.find(".indicator-item").eq(t_6)[0].classList.add("active"));
                }
                if (!this.noWrap || this.center >= 0 && this.center < this.count) {
                    a = this.images[this._wrap(this.center)], t(a).hasClass("active") || (this.$el.find(".carousel-item").removeClass("active"), a.classList.add("active"));
                    var e_5 = h + " translateX(" + -s / 2 + "px) translateX(" + r * this.options.shift * o * i + "px) translateZ(" + this.options.dist * o + "px)";
                    this._updateItemStyle(a, c, 0, e_5);
                }
                for (i = 1; i <= n; ++i) {
                    if (this.options.fullWidth ? (l = this.options.dist, u = i === n && s < 0 ? 1 - o : 1) : (l = this.options.dist * (2 * i + o * r), u = 1 - f * (2 * i + o * r)), !this.noWrap || this.center + i < this.count) {
                        a = this.images[this._wrap(this.center + i)];
                        var t_7 = h + " translateX(" + (this.options.shift + (this.dim * i - s) / 2) + "px) translateZ(" + l + "px)";
                        this._updateItemStyle(a, u, -i, t_7);
                    }
                    if (this.options.fullWidth ? (l = this.options.dist, u = i === n && s > 0 ? 1 - o : 1) : (l = this.options.dist * (2 * i - o * r), u = 1 - f * (2 * i - o * r)), !this.noWrap || this.center - i >= 0) {
                        a = this.images[this._wrap(this.center - i)];
                        var t_8 = h + " translateX(" + (-this.options.shift + (-this.dim * i - s) / 2) + "px) translateZ(" + l + "px)";
                        this._updateItemStyle(a, u, -i, t_8);
                    }
                }
                if (!this.noWrap || this.center >= 0 && this.center < this.count) {
                    a = this.images[this._wrap(this.center)];
                    var t_9 = h + " translateX(" + -s / 2 + "px) translateX(" + r * this.options.shift * o + "px) translateZ(" + this.options.dist * o + "px)";
                    this._updateItemStyle(a, c, 0, t_9);
                }
                var p = this.$el.find(".carousel-item").eq(this._wrap(this.center));
                d !== this.center && "function" == typeof this.options.onCycleTo && this.options.onCycleTo.call(this, p[0], this.dragged), "function" == typeof this.oneTimeCallback && (this.oneTimeCallback.call(this, p[0], this.dragged), this.oneTimeCallback = null);
            };
            i.prototype._updateItemStyle = function (t, e, i, n) { t.style[this.xform] = n, t.style.zIndex = i, t.style.opacity = e, t.style.visibility = "visible"; };
            i.prototype._cycleTo = function (t, e) { var i = this.center % this.count - t; this.noWrap || (i < 0 ? Math.abs(i + this.count) < Math.abs(i) && (i += this.count) : i > 0 && Math.abs(i - this.count) < i && (i -= this.count)), this.target = this.dim * Math.round(this.offset / this.dim), i < 0 ? this.target += this.dim * Math.abs(i) : i > 0 && (this.target -= this.dim * i), "function" == typeof e && (this.oneTimeCallback = e), this.offset !== this.target && (this.amplitude = this.target - this.offset, this.timestamp = Date.now(), requestAnimationFrame(this._autoScrollBound)); };
            i.prototype.next = function (t) { (void 0 === t || isNaN(t)) && (t = 1); var e = this.center + t; if (e >= this.count || e < 0) {
                if (this.noWrap)
                    return;
                e = this._wrap(e);
            } this._cycleTo(e); };
            i.prototype.prev = function (t) { (void 0 === t || isNaN(t)) && (t = 1); var e = this.center - t; if (e >= this.count || e < 0) {
                if (this.noWrap)
                    return;
                e = this._wrap(e);
            } this._cycleTo(e); };
            i.prototype.set = function (t, e) { if ((void 0 === t || isNaN(t)) && (t = 0), t > this.count || t < 0) {
                if (this.noWrap)
                    return;
                t = this._wrap(t);
            } this._cycleTo(t, e); };
            return i;
        }(Component));  M.Carousel = i, M.jQueryLoaded && M.initializeJqueryWrapper(i, "carousel", "M_Carousel"); }(cash);
});
export { patchEsm as a, bootstrapLazy as b, createEvent as c, h, patchBrowser as p, registerInstance as r };
